%define pkgname		SweetHome3D
%define pkgmod		3DModels
%define modelver	1.2.3

Name:		sweethome3d
Version:	4.1
Release:	%mkrel 2
Summary:	A free interior design application, with a 3D preview
Summary(fr_FR):	Une application libre de conception d'intérieur, avec une visualisation en 3D
License:	GPLv2
Group:		Graphics/3D
URL:		http://www.sweethome3d.com/
Source0:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-source/%{pkgname}-%{version}-src.zip
Source1:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-models/%{pkgmod}-Contributions-%{modelver}.zip
Source2:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-models/%{pkgmod}-KatorLegaz-%{modelver}.zip
Source3:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-models/%{pkgmod}-LucaPresidente-%{modelver}.zip
Source4:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-models/%{pkgmod}-Reallusion-%{modelver}.zip
Source5:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-models/%{pkgmod}-Scopia-%{modelver}.zip
Source6:	http://sourceforge.net/projects/%{name}/files/SweetHome3D-models/%{pkgmod}-Trees-%{modelver}.zip
Source10:	sweethome3d_128x128.png
Source11:	sweethome3d-4.1-script
Source20:	http://sourceforge.net/projects/%{pkgname}/files/TexturesLibraryEditor-source/TexturesLibraryEditor-1.2-src.zip
Source21:	http://sourceforge.net/projects/%{pkgname}/files/FurnitureLibraryEditor-source/FurnitureLibraryEditor-1.11-src.zip
Patch0:		sweethome3d-3.2-nomacosx.patch
Patch1:		sweethome3d-4.1-build_xml.patch
Patch2:		sweethome3d-4.1-javadoc.patch
BuildArch:	noarch

BuildRequires:	abbot
BuildRequires:	ant
BuildRequires:	batik
BuildRequires:	desktop-file-utils
BuildRequires:	dos2unix
BuildRequires:	gnu-regexp
BuildRequires:	icedtea-web
BuildRequires:	imagemagick
BuildRequires:	iText
BuildRequires:	java-devel
BuildRequires:	java-javadoc
BuildRequires:	java3d
BuildRequires:	java3d-javadoc
BuildRequires:	java3ds-fileloader
BuildRequires:	jdepend
BuildRequires:	jdom
BuildRequires:	jiprof
BuildRequires:	junit
BuildRequires:	jpackage-utils
BuildRequires:	sunflow
BuildRequires:	xerces-j2
BuildRequires:	xml-commons-apis

Requires:	batik
Requires:	icedtea-web
Requires:	iText
Requires:	janino
Requires:	java
Requires:	java3d
Requires:	java3ds-fileloader
Requires:	jpackage-utils
Requires:	sunflow

Suggests:	%{_lib}cg0

Conflicts:	%{pkgname} < %{version}-%{release}

%description
Sweet Home 3D is a free interior design application that helps you place your
furniture on a house 2D plan, with a 3D preview.
Available at http://www.sweethome3d.eu/, this program is aimed at people who
want to design their interior quickly, whether they are moving or they just
want to redesign their existing home. Numerous visual guides help you draw the
plan of your home and layout furniture. You may draw the walls of your rooms
upon the image of an existing plan, and then, drag and drop furniture onto the
plan from a catalog organized by categories. Each change in the 2D plan is
simultaneously updated in the 3D view, to show you a realistic rendering of
your layout.

%description -l fr_FR
Sweet Home 3D est une application libre de conception d'intérieur qui vous 
aide à placer le mobilier sur un plan 2D, avec une visualisation en 3D.
Disponible à http://www.sweethome3d.eu/, ce programme est dédié à ceux qui 
veulent concevoir rapidement leur intérieur où ils emménagent ou qu'ils 
veulent réagencer. De nombreux guides visuels vous aident à dessiner les 
plans de votre maison et à placer le mobilier. Vous pouvez placer les murs 
de vos pièces sur l'image d'un plan existant, et ensuite glisser-déposer le 
mobilier sur le plan à partir d'un catalogue organisé par catégories. 
Chaque changement dans la vue 2D sera mis à jour dans la vue 3D pour afficher 
le rendu réaliste de votre disposition.

#-----------------------------------------------------------------------------

%package 3dmodels
Group:		Graphics/3D
Summary:	Some extra 3DModels for %{pkgname}
Summary(fr_FR):	Quelques modèles 3D supplémentaires pour %{pkgname}
BuildArch:	noarch
Requires:	%{name} = %{version}-%{release}

%description 3dmodels
Some extra 3DModels for %{pkgname}.
 
This package contains:
* 3DModels Contributions %{modelver}
* 3DModels KatorLegaz %{modelver}
* 3DModels Scopia %{modelver}
* 3DModels Trees %{modelver}
* 3DModels LucaPresidente %{modelver}
* 3DModels Reallusion-%{modelver}

%description 3dmodels -l fr_FR
Quelques modèles 3D supplémentaires pour %{pkgname}.

Ce paquet contient:
* 3DModels Contributions %{modelver}
* 3DModels KatorLegaz %{modelver}
* 3DModels Scopia %{modelver}
* 3DModels Trees %{modelver}
* 3DModels LucaPresidente %{modelver}
* 3DModels Reallusion-%{modelver}

#-----------------------------------------------------------------------------

%package javadoc
Group:		Development/Java
Summary:	Javadoc for %{pkgname}
Summary(fr_FR):	Javadoc pour %{pkgname}
BuildArch:	noarch

%description javadoc
Sweet Home 3D - An application for placing your furniture on a house 2D plan,
with a 3D preview

This package contains javadoc for %{pkgname}.

%description javadoc -l fr_FR
Sweet Home 3D - Une application qui vous aide à placer le mobilier sur un 
plan 2D, avec une visualisation en 3D

Ce paquet contient javadoc pour %{pkgname}.

#-----------------------------------------------------------------------------

%prep 
%setup -q -n %{pkgname}-%{version}-src
%patch0 -p0
%patch1 -p0
%patch2 -p0

for j in $(find . -name "*.jar"); do
  mv $j $j.no
done

rm -rf lib/{windows,macosx,linux}

pushd lib
  ln -sf $(build-classpath batik-all) batik-svgpathparser-1.7.jar
  ln -sf $(build-classpath itext) iText-2.1.7.jar
  ln -sf $(build-classpath java3d/j3dcore) j3dcore.jar
  ln -sf $(build-classpath java3d/j3dutils) j3dutils.jar
  ln -sf $(build-classpath java3ds-fileloader) Loader3DS1_2u.jar
  ln -sf $(build-classpath sunflow) sunflow-0.07.3h.jar
  ln -sf $(build-classpath java3d/vecmath) vecmath.jar
# FIXME for package jar that does not exist on Mageia
   mv jmf.jar.no jmf.jar
   mv freehep-vectorgraphics-svg-2.1.1.jar.no freehep-vectorgraphics-svg-2.1.1.jar
popd

pushd libtest
  ln -sf $(build-classpath abbot) abbot.jar
  ln -sf $(build-classpath gnu-regexp) gnu-regexp-1.1.0.jar
  ln -sf $(build-classpath jdepend) jdepend-2.9.jar
  ln -sf $(build-classpath jdom) jdom-1.0.jar
  ln -sf /usr/share/icedtea-web/netx.jar jnlp.jar
  ln -sf $(build-classpath jiprof/profile) profile.jar
popd

for c in $(find lib -name "*.class"); do
  rm -f $c
done

dos2unix  *.TXT
chmod 644 *.TXT

mkdir -p 3DModels-Contributions
pushd 3DModels-Contributions
    unzip -q %{SOURCE1}
    mv README.TXT README-3DModels-Contributions.txt
    mv LICENSE.TXT LICENSE-3DModels-Contributions.txt
popd
mkdir -p 3DModels-KatorLegaz
pushd 3DModels-KatorLegaz
    unzip -q %{SOURCE2}
    mv README.TXT README-3DModels-KatorLegaz.txt
    mv LICENSE.TXT LICENSE-3DModels-KatorLegaz.txt
popd
mkdir -p 3DModels-LucaPresidente
pushd 3DModels-LucaPresidente
    unzip -q %{SOURCE3}
    mv README.TXT README-3DModels-LucaPresidente.txt
    mv LICENSE.TXT LICENSE-3DModels-LucaPresidente.txt
popd
mkdir -p 3DModels-Reallusion
pushd 3DModels-Reallusion
    unzip -q %{SOURCE4}
    mv README.TXT README-3DModels-Reallusion.txt
    mv LICENSE.TXT LICENSE-3DModels-Reallusion.txt
popd
mkdir -p 3DModels-Scopia
pushd 3DModels-Scopia
    unzip -q %{SOURCE5}
    mv README.TXT README-3DModels-Scopia.txt
    mv LICENSE.TXT LICENSE-3DModels-Scopia.txt
popd
mkdir -p 3DModels-Trees
pushd 3DModels-Trees
    unzip -q %{SOURCE6}
    mv README.TXT README-3DModels-Trees.txt
    mv LICENSE.TXT LICENSE-3DModels-Trees.txt
popd

%build
%ant application furniture textures help javadoc

%install
# .jar-repertory
mkdir -p %{buildroot}%{_javadir}/%{name}
install -pm 644 build/SweetHome3D.jar \
  %{buildroot}%{_javadir}/%{name}/%{pkgname}-%{version}.jar
  
(
  cd %{buildroot}%{_javadir}/%{name}
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`
  done
)

for i in Furniture Textures Help; do
    install -pm 644 build/$i.jar %{buildroot}%{_javadir}/%{name}
done

rm -rf lib/{iText-2.1.7.jar,j3dcore.jar,j3dutils.jar}
rm -rf lib/{sunflow-0.07.3h.jar,vecmath.jar,Loader3DS1_2u.jar}

# FIXME for package jar that does not exist on Mageia
install -pm 644 lib/jmf.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 lib/freehep-vectorgraphics-svg-2.1.1.jar %{buildroot}%{_javadir}/%{name}

# 3Dmodels-repertory
mkdir -p %{buildroot}%{_datadir}/%{name}/%{pkgmod}
for i in Contributions KatorLegaz LucaPresidente Reallusion Scopia Trees; do
    install -m 644 3DModels-$i/*.sh3f %{buildroot}%{_datadir}/%{name}/%{pkgmod}
done

# javadoc-repertory
mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr javadoc/* %{buildroot}%{_javadocdir}/%{name}

# binary-repertory
mkdir -p %{buildroot}%{_bindir}
install -m 755 %{SOURCE11} %{buildroot}%{_bindir}/%{name}

# icons-repertory
mkdir -p %{buildroot}%{_datadir}/pixmaps %{buildroot}%{_iconsdir} %{buildroot}%{_iconsdir}/hicolor/128x128/apps/
cp %{SOURCE10} %{buildroot}%{_iconsdir}/hicolor/128x128/apps/%{name}.png
cp %{SOURCE10} %{buildroot}%{_datadir}/pixmaps/%{name}.png
cp deploy/%{pkgname}*.jpg %{buildroot}%{_iconsdir}
cp deploy/%{pkgname}*.gif %{buildroot}%{_iconsdir}

for png in 64x64 32x32 22x22 16x16; do
    mkdir -p %{buildroot}%{_iconsdir}/hicolor/${png}/apps/
    convert -geometry $png %{SOURCE10} %{buildroot}%{_iconsdir}/hicolor/${png}/apps/%{name}.png
done

# menu-entry
mkdir -p %{buildroot}%{_datadir}/applications
cat > %{name}.desktop <<EOF
[Desktop Entry]
Version=1.0
Name=Sweet Home 3D
Name[fr]=Sweet Home 3D
Name[ru]=Милый дом 3D
GenericName=Sweet Home 3D
GenericName[fr]=Sweet Home 3D
GenericName[ru]=SweetHome 3D
Comment=Design Application
Comment[fr]=Application de conception d'intérieur en 3D
Comment[ru]=Программа проектирования домашнего интерьера в 3D
Exec=%{name}
Icon=%{name}
Terminal=false
Type=Application
StartupNotify=true
StartupWMClass=com-eteks-sweethome3d-SweetHome3D
Categories=Application;Graphics;2DGraphics;3DGraphics;
EOF

desktop-file-install --mode=0644 --dir=%{buildroot}%{_datadir}/applications %{name}.desktop

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/%{name}.desktop

%files
%doc COPYING* LICENSE.TXT README.TXT
%{_bindir}/%{name}
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/Furniture.jar
%{_javadir}/%{name}/Help.jar
%{_javadir}/%{name}/%{pkgname}-%{version}.jar
%{_javadir}/%{name}/%{pkgname}.jar
%{_javadir}/%{name}/Textures.jar
# FIXME for package jar that does not exist on Mageia
%{_javadir}/%{name}/jmf.jar
%{_javadir}/%{name}/freehep-vectorgraphics-svg-2.1.1.jar
#
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.png
%{_iconsdir}/*.jpg
%{_iconsdir}/*.gif
%{_iconsdir}/hicolor/*x*/apps/%{name}.png

%files 3dmodels
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/%{pkgmod}
%{_datadir}/%{name}/%{pkgmod}/*.sh3f
%doc 3DModels-Contributions/*.txt 3DModels-KatorLegaz/*.txt 3DModels-Scopia/*.txt 3DModels-Trees/*.txt 3DModels-LucaPresidente/*.txt 3DModels-Reallusion/*.txt 

%files javadoc
%dir %{_javadocdir}/%{name}
%{_javadocdir}/%{name}/*


%changelog
* Thu Aug 29 2013 david.david (MLO Team) <david.david> 4.1-2.mga3
+ Revision: 2
- rename package to sweethome3d instead of SweetHome3D (Mageia policies)
- fix correct repertory for jar files '%%{_javadir}'
- fix correct build (application furniture textures help)
- fix correct build for sweethome3d-javadoc (javadoc)
- fix script 'SOURCE11' to line "# add some extra catalogs if they exist"
- use correct macro for classpath
- add Patch0: sweethome3d-3.2-nomacosx.patch
- add Patch1: sweethome3d-4.1-build_xml.patch
- add Patch2: sweethome3d-4.1-javadoc.patch
- add some BR and R
- spec file based from mga2

* Fri Jun 21 2013 david.david (MLO Team) <david.david> 4.1-1.mga3
+ new version: 4.1
- update P0
- add Suggests: libcg0

* Sat Jun 01 2013 david.david (MLO Team) <david.david> 4.0-3.mga3
+ Rebuild package for Mageia 3 (Core)
- add repertory 3Dmodels to /usr/share/SweetHome3D
- move the extra 3DModels in this new directory

* Fri May 31 2013 david.david (MLO Team) <david.david> 4.0-2.mga3
+ Rebuild package for Mageia 3 (Core)
- imported package from Rosa
- add package javadoc and 3dmodels
- add french language in %%description and %%Summary
- add french comment in .desktop
- new version: 4.0

* Wed May 16 2012 Sergey Zhemoitel <serg@mandriva.org> 3.5-4mdv2011.0
+ Revision: 799155
- update to 3.5 release 2
- update to version 3.5
- add new release 3.4
- new version 3.3
- new release 3.3, added package with source code
- add russian comment in .desktop

* Fri Jul 22 2011 Sergey Zhemoitel <serg@mandriva.org> 3.2-1
+ Revision: 690943
- imported package SweetHome3D